"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JavaAnalyzerOutput = void 0;
const AnalyzerOutput_1 = require("../AnalyzerOutput");
class JavaAnalyzerOutput extends AnalyzerOutput_1.AnalyzerOutput {
    constructor() {
        super(...arguments);
        this._progressPattern = /\[(?<value>(\s|\d)+)%\]/gm;
    }
    tryGetWarningFromOutputLine(outputLine) {
        if (outputLine.startsWith("{")) {
            try {
                return JSON.parse(outputLine);
            }
            catch (_a) { }
        }
    }
    tryGetProgressFromOutputLine(outputLine) {
        const match = this._progressPattern.exec(outputLine);
        if (match) {
            return parseInt(match.groups.value.trim());
        }
    }
    tryGetSupressedCountFromOutputLine(outputLine) {
        return;
    }
    tryGetNoLicenseMessage(outputLine) {
        if (outputLine.toLowerCase().includes("time out license")) {
            return "Time out license. Contact us at support@viva64.com.";
        }
        const index = outputLine.indexOf("License was not entered");
        if (index >= 0) {
            return outputLine.substring(index);
        }
    }
}
exports.JavaAnalyzerOutput = JavaAnalyzerOutput;
//# sourceMappingURL=JavaAnalyzerOutput.js.map