"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MSBuildAnalyzerOutput = void 0;
const AnalyzerOutput_1 = require("../AnalyzerOutput");
class MSBuildAnalyzerOutput extends AnalyzerOutput_1.AnalyzerOutput {
    constructor() {
        super(...arguments);
        this._warningPattern = /\{.+\}/gm;
        this._progressPattern = /\<#~\>(?<current>\d+)\<#~\>(?<target>\d+)\<#~\>/gm;
        this._newLinePattern = /\r\n?|\n\r?/gm;
    }
    tryGetWarningFromOutputLine(outputLine) {
        try {
            const matchIndex = outputLine.search(this._warningPattern);
            if (matchIndex >= 0) {
                const value = outputLine.slice(matchIndex).trim();
                const warning = JSON.parse(value);
                if (Array.isArray(warning.projects)) {
                    console.log(warning.projects);
                }
                if (warning.projects instanceof String && warning.projects.includes(",")) {
                    console.log(warning.projects);
                }
                return warning;
            }
        }
        catch (_a) { }
    }
    tryGetProgressFromOutputLine(outputLine) {
        const match = this._progressPattern.exec(outputLine);
        if (match) {
            const current = parseInt(match.groups.current) + 1;
            const target = parseInt(match.groups.target) + 1;
            return current / target * 100;
        }
    }
    tryGetSupressedCountFromOutputLine(outputLine) {
        return;
    }
    tryGetNoLicenseMessage(outputLine) {
        let index = outputLine.indexOf("License was not entered");
        if (index >= 0) {
            return outputLine.substring(index).replaceAll(this._newLinePattern, " ");
        }
        if (outputLine.includes("license has expired")) {
            return outputLine.replaceAll(this._newLinePattern, " ");
        }
    }
}
exports.MSBuildAnalyzerOutput = MSBuildAnalyzerOutput;
//# sourceMappingURL=MSBuildAnalyzerOutput.js.map