"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAnalyzerArgsInfo = exports.MSBuildAnalyzerArgs = exports.MSBuildAnalyzerRunConfig = void 0;
const MSBuildAnalyzerParam_1 = require("../MSBuildAnalyzerParam");
class MSBuildAnalyzerRunConfig {
    constructor() {
        this.analysisArguments = [];
    }
}
exports.MSBuildAnalyzerRunConfig = MSBuildAnalyzerRunConfig;
const analyzerArgsInfoKey = Symbol("analyzerParametersInfo");
class MSBuildAnalyzerArgs {
    constructor() {
        this.platform = "";
        this.configuration = "";
    }
}
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.sourceFiles)
], MSBuildAnalyzerArgs.prototype, "sourceFile", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.platform)
], MSBuildAnalyzerArgs.prototype, "platform", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.configuration)
], MSBuildAnalyzerArgs.prototype, "configuration", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.msBuildProperties)
], MSBuildAnalyzerArgs.prototype, "msBuildProperties", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.excludeDefines)
], MSBuildAnalyzerArgs.prototype, "excludeDefines", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.appendDefines)
], MSBuildAnalyzerArgs.prototype, "appendDefines", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.selectProjects)
], MSBuildAnalyzerArgs.prototype, "selectProjects", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.excludeProjects)
], MSBuildAnalyzerArgs.prototype, "excludeProjects", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.rulesConfig)
], MSBuildAnalyzerArgs.prototype, "rulesConfig", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.dependencyRoot)
], MSBuildAnalyzerArgs.prototype, "dependencyRoot", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.dependencyCacheSourcesRoot)
], MSBuildAnalyzerArgs.prototype, "dependencyCacheSourcesRoot", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.ignoreGlobalRulesConfig)
], MSBuildAnalyzerArgs.prototype, "ignoreGlobalRulesConfig", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.useSuppressFile)
], MSBuildAnalyzerArgs.prototype, "useSuppressFiles", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.regenerateDependencyCache)
], MSBuildAnalyzerArgs.prototype, "regenerateDependencyCacheWithMode", void 0);
__decorate([
    analyzerArgument(MSBuildAnalyzerParam_1.MSBuildAnalyzerParam.intermodular)
], MSBuildAnalyzerArgs.prototype, "intermodular", void 0);
exports.MSBuildAnalyzerArgs = MSBuildAnalyzerArgs;
function analyzerArgument(param) {
    return (target, property) => {
        let argInfo = target[analyzerArgsInfoKey];
        if (!argInfo) {
            argInfo = target[analyzerArgsInfoKey] = [];
        }
        argInfo.push({ parameter: param, propertyName: property });
    };
}
function getAnalyzerArgsInfo() {
    return MSBuildAnalyzerArgs.prototype[analyzerArgsInfoKey];
}
exports.getAnalyzerArgsInfo = getAnalyzerArgsInfo;
//# sourceMappingURL=MSBuildAnalyzerRunConfig.js.map