"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultSettings = void 0;
let _defaultSettings;
function getDefaultSettings() {
    if (_defaultSettings) {
        return _defaultSettings;
    }
    _defaultSettings = {
        sourceTreeRoot: "",
        analysis: {
            threadCount: 8,
            timeout: { id: "After_60_minutes", value: 3600, name: "After 60 minutes" },
            removeIntermediateFiles: true,
            securityRelatedIssues: false
        },
        falseAlarms: {
            show: false,
            saveFile: false,
            message: false,
        },
        columns: [
            {
                id: "id",
                visible: false,
            },
            {
                id: "cwe",
                visible: false,
            },
            {
                id: "sastId",
                visible: false,
            },
            {
                id: "projects",
                visible: false,
            },
        ],
        documentationLang: "en",
        disabledDiagnostics: [
            {
                "code": "V001",
                "lang": "cpp",
                "group": "fails"
            },
            {
                "code": "V004",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V051",
                "lang": "cs",
                "group": "fails"
            },
            {
                "code": "V101",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V102",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V103",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V104",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V105",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V106",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V107",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V108",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V109",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V110",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V111",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V112",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V113",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V114",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V115",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V116",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V117",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V118",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V119",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V120",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V121",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V122",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V123",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V124",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V125",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V126",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V127",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V128",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V201",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V202",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V203",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V204",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V205",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V206",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V207",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V220",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V221",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V301",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V302",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V303",
                "lang": "cpp",
                "group": "64"
            },
            {
                "code": "V2001",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2002",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2003",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2004",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2005",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2006",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2007",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2008",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2009",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2010",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2011",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2012",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2013",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2014",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2015",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2016",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2017",
                "lang": "cpp",
                "group": "cs"
            },
            {
                "code": "V2501",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2502",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2503",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2504",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2505",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2506",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2507",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2508",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2509",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2510",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2511",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2512",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2513",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2514",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2515",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2516",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2517",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2518",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2519",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2520",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2521",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2522",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2523",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2524",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2525",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2526",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2527",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2528",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2529",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2530",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2531",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2532",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2533",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2534",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2535",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2536",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2537",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2538",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2539",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2540",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2541",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2542",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2543",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2544",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2545",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2546",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2547",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2548",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2549",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2550",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2551",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2552",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2553",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2554",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2555",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2556",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2557",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2558",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2559",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2560",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2561",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2562",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2563",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2564",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2565",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2566",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2567",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2568",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2569",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2570",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2571",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2572",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2573",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2574",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2575",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2576",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2577",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2578",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2579",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2580",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2581",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2582",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2583",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2584",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2585",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2586",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2587",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2588",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2589",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2590",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2591",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2592",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2593",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2594",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2595",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2596",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2597",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2598",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2599",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2600",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2601",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2602",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2603",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2604",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2605",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2606",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2607",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2608",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2609",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2610",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2611",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2612",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2613",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2614",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2615",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2616",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2617",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2618",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2619",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2620",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2621",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V2622",
                "lang": "cpp",
                "group": "misra"
            },
            {
                "code": "V3501",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3502",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3503",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3504",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3505",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3506",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3507",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3508",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3509",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3510",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3511",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3512",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3513",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3514",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3515",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3516",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3517",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3518",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3519",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3520",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3521",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3522",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3523",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3524",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3525",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3526",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3527",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3528",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3529",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3530",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3531",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3532",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3533",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3534",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3535",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3536",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3537",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3538",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3539",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3540",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3541",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3542",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3543",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3544",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3545",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3546",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3547",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3548",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3549",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3550",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3551",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3552",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3553",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3554",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V3555",
                "lang": "cpp",
                "group": "autosar"
            },
            {
                "code": "V5001",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5002",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5003",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5004",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5005",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5006",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5007",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5008",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5009",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5010",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5011",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5012",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5013",
                "lang": "cpp",
                "group": "owasp"
            },
            {
                "code": "V5601",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5602",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5603",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5604",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5605",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5606",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5607",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5608",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5609",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5610",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5611",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5612",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5613",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5614",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5615",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5616",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5617",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5618",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5619",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5620",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5621",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5622",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5623",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5624",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5625",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5626",
                "lang": "cs",
                "group": "owasp"
            },
            {
                "code": "V5301",
                "lang": "java",
                "group": "owasp"
            },
            {
                "code": "V5302",
                "lang": "java",
                "group": "owasp"
            },
            {
                "code": "V5303",
                "lang": "java",
                "group": "owasp"
            },
            {
                "code": "V5304",
                "lang": "java",
                "group": "owasp"
            },
            {
                "code": "V5305",
                "lang": "java",
                "group": "owasp"
            }
        ],
        excludedPaths: [
            "*/boost/*",
            "*/zlib/*",
            "*/png/*",
            "*/libpng/*",
            "*/pnglib/*",
            "*/freetype/*",
            "*/ImageMagick/*",
            "*/jpeglib/*",
            "*/libxml/*",
            "*/libxslt/*",
            "*/tifflib/*",
            "*/wxWidgets/*",
            "*/libtiff/*",
            "*/mesa/*",
            "*/cximage/*",
            "*/bzip2-",
            "*/bzip2/*",
            "*/UE_*/Engine/Source/*",
            "*.tlh",
            "*.tli",
        ]
    };
    return _defaultSettings;
}
exports.getDefaultSettings = getDefaultSettings;
//# sourceMappingURL=defaultSettings.js.map