"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayUtils = void 0;
class ArrayUtils {
    static mapAsync(array, mapFunc) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield Promise.all(array.map(mapFunc)));
        });
    }
    static filterAsync(array, filterFunc) {
        return __awaiter(this, void 0, void 0, function* () {
            const filterMap = yield this.mapAsync(array, filterFunc);
            return array.filter((_, index) => filterMap[index]);
        });
    }
}
exports.ArrayUtils = ArrayUtils;
//# sourceMappingURL=arrayUtils.js.map