"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.changeObjectProp = void 0;
/**
 * Меняет значение поля исходного объекта, можно использовать для nested полей
 * @param obj объект, в котором надо изменить поле
 * @param path массив полей до необходимого поля
 * (ex.: ["address", "city"] нужен чтоб поменять значение в объекте { address: { city: "London" } })
 * @param value значение поля, которое надо изменить
 * @returns преобразованный объект
 */
function changeObjectProp(obj, path, value) {
    const newObj = JSON.parse(JSON.stringify(obj));
    let current = newObj;
    for (let i = 0; i < path.length - 1; i++) {
        if (!current[path[i]]) {
            current[path[i]] = {};
        }
        current = current[path[i]];
    }
    current[path[path.length - 1]] = value;
    return newObj;
}
exports.changeObjectProp = changeObjectProp;
//# sourceMappingURL=changeObjectProp.js.map