"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getJsonFromFile = void 0;
const fs = require("fs");
//@ts-ignore
const bigJson = require("big-json");
//@ts-ignore
const removeBOM = require("remove-bom-stream");
/**
 * Читает .json файл по данному пути и извлекает из него JSON объект
 * @param fsPath {string} - путь до .json файла отчета PVS-Studio
 * @returns {Promise<object>} JSON объект из отчета
 */
function getJsonFromFile(fsPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const readStream = fs.createReadStream(fsPath);
        const parseStream = bigJson.createParseStream();
        readStream.pipe(removeBOM("utf-8")).pipe(parseStream);
        const json = new Promise((resolve, reject) => {
            parseStream.on("data", function (pojo) {
                resolve(pojo);
            });
            parseStream.on("error", function (error) {
                reject(new Error(`Incorrect format of JSON file: ${fsPath}.`));
            });
            parseStream.on("end", function () {
                resolve({});
            });
        });
        return json;
    });
}
exports.getJsonFromFile = getJsonFromFile;
//# sourceMappingURL=getJsonFromFile.js.map